#pragma once

#include <memory>
#include <string>

#include <GLFW/glfw3.h>

class Window {
public:
    [[nodiscard]]
    static auto vulkan_instance_extensions() -> std::span<const char* const>;

    explicit Window(uint16_t width, uint16_t height, const std::string& title);

    [[nodiscard]]
    auto get() const noexcept -> GLFWwindow*;

    [[nodiscard]]
    auto framebuffer_size() const noexcept -> vk::Extent2D;

    [[nodiscard]]
    auto create_vulkan_surface(vk::Instance instance) const -> vk::UniqueSurfaceKHR;

private:
    std::unique_ptr<GLFWwindow, decltype(&glfwDestroyWindow)> m_impl;
};
